#!/bin/sh
#
#  xruntrace1.sh
#
#  Real-Time Preemption, -RT-2.6.10-rc2-mm2-V0.7.30-9
#
#  User-triggerable ALSA xrun tracing patch: if a sound IO channel has
#  xrun_debug enabled in /proc then user_trace_stop() will be called
#  before printing the xrun message, and the current trace will be saved
#  to /proc/latency_trace. This is a 'one-shot' tracing method for now.
#
case $1 in
start)
 #for x in /proc/asound/card*/pcm*/xrun_debug; do echo 1 > $x; done
  echo 1    > /proc/sys/kernel/trace_enabled
  echo 1    > /proc/sys/kernel/trace_user_triggered
 #echo 1    > /proc/sys/kernel/trace_freerunning
  echo 0    > /proc/sys/kernel/preempt_max_latency
  echo 0    > /proc/sys/kernel/preempt_thresh
  echo 0    > /proc/sys/kernel/preempt_wakeup_timing
 #./gettimeofday 0 1
  ;;
stop)
 #for x in /proc/asound/card*/pcm*/xrun_debug; do echo 0 > $x; done
  echo 0    > /proc/sys/kernel/trace_enabled
  echo 0    > /proc/sys/kernel/trace_user_triggered
 #echo 0    > /proc/sys/kernel/trace_freerunning
  echo 0    > /proc/sys/kernel/preempt_max_latency
  echo 1000 > /proc/sys/kernel/preempt_thresh
  echo 1    > /proc/sys/kernel/preempt_wakeup_timing
 #./gettimeofday 0 0
  ;;
status)
  grep . /proc/asound/card*/pcm*/*xrun*
  grep . /proc/sys/kernel/*trace*
  grep . /proc/sys/kernel/*preempt*
  ;;
esac

